#include <stdio.h>
#include <string.h>
#include <sys/mman.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>


int main(int argc, char *argv[]) {
 struct stat st;
 char content[10];
 char *new = "NUEVO";
 void *map;

 int f = open("/etc/hosts", O_RDWR|RD_ONLY);
 fstat(f, &st);
 map = mmap(NULL, st.st_size, PROT_READ|PROT_WRITE, MAP_SHARED|MAP_PRIVATE, f, 0);
 
 // Leer 10 bytes del pseudofichero en memoria
 memcpy((void*)content, map, 10);
 printf("Lectura [%s]\n", content);
 // Escribir en memoria
 memcpy(map + 5, new, strlen(new));
 
 // Limpiar
 munmap(map, st.st_size);
 close(f);
 return 0; 
}
