#include <stdio.h>
#include <string.h>
#include <sys/mman.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>


int main(int argc, char *argv[]) {
 char *content = "*** CAMBIADO ***";
 char buffer[30];
 struct stat st;
 void *map;

 int f = open("./rofile.txt", O_RDONLY);
 fstat(f, &st);
 map = mmap(NULL, st.st_size, PROT_READ, MAP_PRIVATE, f, 0);
 
 // Memoria del proceso del pseudofichero
 int fm = open("/proc/self/mem", O_RDWR);
 // Saltar al quinto byte
 lseek(fm, (off_t) map + 5, SEEK_SET);
 // Escribir en la memoria
 write(fm, content, strlen(content));
 // Comprobar la escritura en la memoria
 memcpy(buffer, map, 29);
 printf("Contenido tras escritura [%s]\n", buffer);
 // Contenido tras madvise
 madvise(map, st.st_size, MADV_DONTNEED);
 memcpy(buffer, map, 29);
 printf("Contenido tras madvise [%s]\n", buffer);

 // Limpiar
 munmap(map, st.st_size);
 close(f);
 return 0; 
}
